// Fig. F.2: DesktopDemo.java
// Use Desktop to launch default browser, open a file in its associated 
// application and compose an email in the default email client.
import java.awt.Desktop;
import java.io.File;
import java.io.IOException;
import java.net.URI;

public class DesktopDemo extends javax.swing.JFrame
{   
   // constructor
   public DesktopDemo()
   {
      initComponents();
   } // end DesktopDemo constructor
   
   // To save space, lines 20-84 of the Netbeans autogenerated GUI code 
   // are not shown here. The complete code for this example is located in
   // the file DesktopDemo.java in this example's directory.
   // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
   private void initComponents()
   {
      instructionLabel = new javax.swing.JLabel();
      inputJTextField = new javax.swing.JTextField();
      tasksJComboBox = new javax.swing.JComboBox();
      inputJLabel = new javax.swing.JLabel();
      doTaskJButton = new javax.swing.JButton();

      setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
      setTitle("Desktop Class Demonstration");
      instructionLabel.setText("Select a task:");

      tasksJComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Open default browser", "Open file in associated application", "Open email composition window" }));

      inputJLabel.setText("Enter file name or URL for selected command to process:");

      doTaskJButton.setText("Do Task");
      doTaskJButton.addActionListener(new java.awt.event.ActionListener()
      {
         public void actionPerformed(java.awt.event.ActionEvent evt)
         {
            doTaskJButtonActionPerformed(evt);
         }
      });

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
               .addComponent(instructionLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 243, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(inputJTextField)
               .addComponent(tasksJComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
               .addComponent(inputJLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
               .addComponent(doTaskJButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );
      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(instructionLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(tasksJComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(inputJLabel)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(inputJTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(doTaskJButton)
            .addContainerGap())
      );
      pack();
   }// </editor-fold>//GEN-END:initComponents

   // determine selected task and perform the task
   private void doTaskJButtonActionPerformed(//GEN-FIRST:event_doTaskJButtonActionPerformed
      java.awt.event.ActionEvent evt)
   {//GEN-HEADEREND:event_doTaskJButtonActionPerformed
      int index = tasksJComboBox.getSelectedIndex();
      String input = inputJTextField.getText();
      
      if ( Desktop.isDesktopSupported() )
      {
         try
         {
            Desktop desktop = Desktop.getDesktop();
            
            switch ( index )
            {
               case 0: // open browser
                  desktop.browse( new URI( input ) );
                  break;
               case 1: // open file
                  desktop.open( new File( input ) );
                  break;
               case 2: // open email composition window
                  desktop.mail( new URI( input ) );
                  break;
            } // end switch
         } // end try
         catch ( Exception e )
         {
            e.printStackTrace();
         } // end catch      
      }
   }//GEN-LAST:event_doTaskJButtonActionPerformed
   
   public static void main(String args[])
   {
      java.awt.EventQueue.invokeLater(
         new Runnable()
         {
            public void run()
            {
               new DesktopDemo().setVisible(true);
            }
         }
      );
   } // end method main
   
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JButton doTaskJButton;
   private javax.swing.JLabel inputJLabel;
   private javax.swing.JTextField inputJTextField;
   private javax.swing.JLabel instructionLabel;
   private javax.swing.JComboBox tasksJComboBox;
   // End of variables declaration//GEN-END:variables
}
